@ECHO OFF
@SETLOCAL
::Set Version Info
SET Version=20150618
::Set title
SET COMMAND_PROMPT_WINDOW_TITLE=SuccessFactors Performance Diagnostic Tool
title %COMMAND_PROMPT_WINDOW_TITLE%
::Set production mame
SET ProductName=Performance Diagnostic Tool
ECHO.
:: 80 characters each line
ECHO   **************************************************************************
ECHO   **  Name: %ProductName%                                   **
ECHO   **  Description: This tool automatically collects performance diagnostic**
ECHO   **  information on user's computer to help performance troubleshooting  **
ECHO   **  Version: %Version%                                                   **
ECHO   **  Copyright: (C) Copyright 2015 SuccessFactors, an SAP Company        **
ECHO   **************************************************************************
ECHO.

:: For IE 5.x and WinXP
IF NOT "%OS%"=="Windows_NT" GOTO Usage

:: Check if WMIC are available
WMIC.EXE    /? >NUL 2>&1 || GOTO Usage

rem setlocal enabledelayedexpansion
SET KEY_QUERY_VALUE="&H1"
SET KEY_SET_VALUE="&H2"
SET KEY_CREATE_SUB_KEY="&H4"
SET KEY_ENUMERATE_SUB_KEYS="&H8"
SET KEY_NOTIFY="&H10"
SET KEY_CREATE="&H20"
SET DELETE="&H10000"
SET READ_CONTROL="&H20000"
SET WRITE_DAC="&H40000"
SET WRITE_OWNER="&H80000"

SET HKEY_CLASSES_ROOT="&H80000000"
SET HKEY_CURRENT_USER="&H80000001"
SET HKEY_LOCAL_MACHINE="&H80000002"
SET HKEY_USERS="&H80000003"
SET HKEY_CURRENT_CONFIG="&H80000005"

:: Get current time and date
:: For REG.EXE 3.0 (Windows XP) and later versions

:: Get the time from WMI - at least that's a format we can work with

for /f "skip=1 delims=" %%x in ('wmic os get localdatetime') do if not defined X set X=%%x
rem dissect into parts
set Year=%X:~0,4%
set Month=%X:~4,2%
set Day=%X:~6,2%
set Hours=%X:~8,2%
set Minutes=%X:~10,2%
:: Set file name
SET OutputFileName=perf_data_%Year%_%Month%_%Day%_%Hours%%Minutes%.html
SET ErrorOutputFileName=error_log_%Year%_%Month%_%Day%_%Hours%%Minutes%.txt
SET ERROR=0

:: Set result, script and log path
IF NOT EXIST "%~dp0"\Results\ (
	MKDIR "%~dp0"\Results\
)
IF NOT EXIST "%~dp0"\Logs\ (
	MKDIR "%~dp0"\Logs\
)
SET ScriptPath=%~dp0\Scripts
SET ResultPath=%~dp0\Results\%OutputFileName%
SET LogPath=%~dp0\Logs\%ErrorOutputFileName%

:: SF Bandwidth test URLs
:: For DCs
SET AZURL=https://performancemanager4.successfactors.com
SET EUURL=https://performancemanager.successfactors.eu
SET ASHURL=https://performancemanager8.successfactors.com
SET AUURL=https://performancemanager10.successfactors.com
SET SHURL=https://performancemanager15.sapsf.cn
SET TOURL=https://hcm17.sapsf.com
:: For Akamai
SET PM12EUURL=https://performancemanager12.successfactors.eu
SET PM2CNCDNURL=https://pm2-cncdn.successfactors.eu
SET PM012CDNURL=https://performancemanager012-cdn.successfactors.eu
SET PM52URL=https://performancemanager52.successfactors.eu
SET PM5CNCDNURL=https://pm5-cncdn.successfactors.eu
SET PM41URL=https://performancemanager41.successfactors.com
SET PM42URL=https://performancemanager42.successfactors.com
SET PM4CNCDNURL=https://pm4-cncdn.successfactors.com
SET AMWAYURL=https://amway.successfactors.com
SET PM8CDNURL=https://performancemanager8-cdn.successfactors.com
SET PM11URL=https://performancemanager11.successfactors.com
SET PM12COMURL=https://performancemanager12.successfactors.com
SET PM8CNCDNURL=https://pm8-cncdn.successfactors.com
SET PM10CDNURL=https://performancemanager10-cdn.successfactors.com
SET PM10CNCDNURL=https://pm10-cncdn.successfactors.com

:: For DCs
SET AZ=performancemanager4.successfactors.com
SET EU=performancemanager.successfactors.eu
SET EUDC5=performancemanager5.successfactors.eu
SET EUDC16=hcm16.sapsf.eu
SET ASH=performancemanager8.successfactors.com
SET AU=performancemanager10.successfactors.com
SET SH=performancemanager15.sapsf.cn
SET TO=hcm17.sapsf.com
:: For Akamai
SET PM12EU=performancemanager12.successfactors.eu
SET PM2CNCDN=pm2-cncdn.successfactors.eu
SET PM012CDN=performancemanager012-cdn.successfactors.eu
SET PM52=performancemanager52.successfactors.eu
SET PM5CNCDN=pm5-cncdn.successfactors.eu
SET PM41=performancemanager41.successfactors.com
SET PM42=performancemanager42.successfactors.com
SET PM4CNCDN=pm4-cncdn.successfactors.com
SET AMWAY=amway.successfactors.com
SET PM8CDN=performancemanager8-cdn.successfactors.com
SET PM11=performancemanager11.successfactors.com
SET PM12COM=performancemanager12.successfactors.com
SET PM8CNCDN=pm8-cncdn.successfactors.com
SET PM10CDN=performancemanager10-cdn.successfactors.com
SET PM10CNCDN=pm10-cncdn.successfactors.com

SET MYDC=performancemanager4.successfactors.com

:: Build up the basic html header
ECHO ^<html^> > "%ResultPath%"
ECHO ^<head^> >> "%ResultPath%"
ECHO ^<title^>Test Result on %Month%/%Day%/%Year% %Hours%:%Minutes%, Generated By Performance Tool(%Version%)^</title^> >> "%ResultPath%"
ECHO ^<script defer="defer" ^> >> "%ResultPath%"
ECHO function removeEmptyLine^(^)^{>> "%ResultPath%"
ECHO   var	num = document.getElementById^("Traceroute_result"^).getElementsByTagName^("tr"^);>> "%ResultPath%"
ECHO   for^( var i=0;i^<num.length;i++^)^{>> "%ResultPath%"
ECHO     s_value_Traceroute = document.getElementById^("Traceroute_result"^).rows^[i^].cells^[1^].innerHTML;>> "%ResultPath%"
ECHO     s_value_Ping = document.getElementById^("ping_result"^).rows^[i^].cells^[1^].innerHTML;>> "%ResultPath%"
ECHO     t_value_Traceroute=s_value_Traceroute.replace^(/\r/ig,"<br>"^).replace^(/\n/ig,"<br>"^);>> "%ResultPath%"
ECHO     t_value_Ping = s_value_Ping.replace^(/\r/ig,"<br>"^).replace^(/\n/ig,"<br>"^);>> "%ResultPath%"
ECHO     document.getElementById^("Traceroute_result"^).rows^[i^].cells^[1^].innerHTML = t_value_Traceroute.replace^("<br><br><br><br>","\r\n"^).replace^("<br><br>","\r\n"^);>> "%ResultPath%"
ECHO     document.getElementById^("ping_result"^).rows^[i^].cells^[1^].innerHTML = t_value_Ping.replace^("<br><br><br><br>","\r\n"^).replace^("<br><br>","\r\n"^);>> "%ResultPath%"
ECHO   ^}>> "%ResultPath%"
ECHO ^}>> "%ResultPath%"
ECHO ^</script^> >> "%ResultPath%"
ECHO ^</head^> >> "%ResultPath%"
ECHO ^<body onload="removeEmptyLine();" style="font-family:verdana"^> >> "%ResultPath%"
ECHO ^<p^>^<font size="5"^>%ProductName% (Version: %Version%)^</font^>^</p^> >> "%ResultPath%"
ECHO ^<p^>^<font size="5"^>Test Result on %Month%/%Day%/%Year% %Hours%:%Minutes%^</font^>^</p^> >> "%ResultPath%"
@rem ECHO    Note: Results will be generated into in %ResultPath%
:: Collect customer information (name and datacenter)
ECHO ^<p^>^<font size="5"^>Customer Information:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>Customer Name^</th^> >> "%ResultPath%"
ECHO ^<th^>Datacenter^</th^> >> "%ResultPath%"
ECHO ^</tr^> >>"%ResultPath%"
ECHO ^<tr^> >> "%ResultPath%"
:: Collect customer name

SET /p cn=Please type the customer name for running the test (e.g. ACE123):
ECHO ^<td^>%cn%^</td^> >> "%ResultPath%"
:: Collect datacenter
ECHO.
@rem ECHO    **************************************************************************
@rem ECHO    **  SuccessFactors hosts customer data in following datacenters:        **
@rem ECHO    **  a. Arizona (AZ, %AZ%)             **
@rem ECHO    **  b. Europe (EU, %EU%,                 **
@rem ECHO    **                %EUDC5%,            **
@rem ECHO    **                and %EUDC16%)            **
@rem ECHO    **  c. Ashburn (ASH, %ASH%)            **
@rem ECHO    **  d. Australia (AU, %AU%)            **
@rem ECHO    **  e. Shanghai (SH, %SH%)            **
@rem ECHO    **  e. Toronto (TO, %TO%)            **
@rem ECHO    **************************************************************************
ECHO   SuccessFactors hosts customer data in following datacenters:
ECHO   * Arizona	(AZ, %AZ%) 
ECHO   * Europe	(EU, %EU%;
ECHO           	     %EUDC5%;
ECHO           	     and %EUDC16%)            
ECHO   * Ashburn	(ASH, %ASH%)
ECHO   * Australia	(AU, %AU%)
ECHO   * Shanghai	(SH, %SH%) 
ECHO   * Toronto	(TO, %TO%) 
ECHO.
ECHO   Akamai is enabled with below site:
ECHO   * Europe:
ECHO   * 	pm12eu,    performancemanager12.successfactors.eu
ECHO   * 	pm2cncdn,  pm2-cncdn.successfactors.eu
ECHO   * 	pm012cdn,  performancemanager012-cdn.successfactors.eu
ECHO   * 	pm52,      performancemanager52.successfactors.eu
ECHO   * 	pm5cncdn,  pm5-cncdn.successfactors.eu
ECHO   * Arizona:
ECHO   * 	pm41,      performancemanager41.successfactors.com
ECHO   * 	pm42,      performancemanager42.successfactors.com
ECHO   * 	pm4cncdn,  pm4-cncdn.successfactors.com
ECHO   * 	amway,     amway.successfactors.com
ECHO   * Ashburn:
ECHO   * 	pm8cdn,    performancemanager8-cdn.successfactors.com
ECHO   * 	pm11,      performancemanager11.successfactors.com
ECHO   * 	pm12com,   performancemanager12.successfactors.com
ECHO   * 	pm8cncdn,  pm8-cncdn.successfactors.com
ECHO   * Australia:
ECHO   * 	pm10cdn,   performancemanager10-cdn.successfactors.com
ECHO   * 	pm10cncdn, pm10-cncdn.successfactors.com

SET /p dc=Please type datacenter name, short name of Akamai site or URL that the customer located (e.g. AZ), or press Enter to test all datacenters:
ECHO.

ECHO ^<td^>%dc%^</td^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"
ECHO ^</table^> >> "%ResultPath%"
:: Build up table for IE setting
ECHO ^<p^>^<font size="5"^>IE Browser Setting:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>^&nbsp;^</th^> >> "%ResultPath%"
ECHO ^<th^>IE Version^</th^> >> "%ResultPath%"
ECHO ^<th^>Check for newer versions of stored pages^</th^> >> "%ResultPath%"
ECHO ^<th^>The amount of disk space to use for Temporary Internet Files folder^</th^> >> "%ResultPath%"
ECHO ^<th^>Use Http 1.1^</th^> >> "%ResultPath%"
ECHO ^<th^>Use Http 1.1 through proxy connections^</th^> >> "%ResultPath%"
ECHO ^<th^>Do not save encrypted pages to disk^</th^> >> "%ResultPath%"
ECHO ^<th^>Empty temporary internet files folder when browser is closed^</th^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"


ECHO Collecting IE Browser Setting...
:: First check if current user has permission to query registry entry of internet setting
WMIC /NameSpace:\\root\default Class StdRegProv Call CheckAccess hDefKey=%HKEY_CURRENT_USER% sSubKeyName="Software\Microsoft\Windows\CurrentVersion\Internet Settings" uRequired=%KEY_QUERY_VALUE% 1>NUL 2>>"%LogPath%"
IF ERRORLEVEL 0 (
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>Recommended Setting^</td^> >> "%ResultPath%"
	ECHO ^<td^>^Internet Explorer 8.0+^</td^> >> "%ResultPath%"
	ECHO ^<td^>Automatically^</td^> >> "%ResultPath%"
	ECHO ^<td^>1024MB^</td^> >> "%ResultPath%"
	ECHO ^<td^>Yes^</td^> >> "%ResultPath%"
	ECHO ^<td^>Yes^</td^> >> "%ResultPath%"
	ECHO ^<td^>Not checked^</td^> >> "%ResultPath%"
	ECHO ^<td^>Not checked^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"	
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>Your Setting^</td^> >> "%ResultPath%"
	CALL :CollectIESetting 1>NUL 2>>"%LogPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	ECHO ^</table^> >> "%ResultPath%"
) ELSE ( 
	SET /a ERROR+=1
	ECHO ^<p^>^<font color=red^>User doesn't have permission to query regsitry entry of internet setting^</font^>^</p^> >> "%ResultPath%"
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	ECHO ^</table^> >> "%ResultPath%"
)
ECHO Collecting IE Browser Setting Done
:: Build up table for system info
ECHO ^<p^>^<font size="5"^>System Information:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>Machine Name^</th^> >> "%ResultPath%"
ECHO ^<th^>OS Name^</th^> >> "%ResultPath%"
ECHO ^<th^>OS Version^</th^> >> "%ResultPath%"
ECHO ^<th^>Processor info^</th^> >> "%ResultPath%"
ECHO ^<th^>Total physical memory^</th^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"

ECHO Collecting System Information...
:: Collect System info
WMIC /NameSpace:\\root\default Class StdRegProv Call CheckAccess hDefKey=%HKEY_LOCAL_MACHINE% sSubKeyName="HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" uRequired=%KEY_QUERY_VALUE% 1>nul 2>>"%LogPath%"
IF ERRORLEVEL 0 ( 
	ECHO ^<tr^> >> "%ResultPath%"
	CALL :CollectOsInfo 1>nul 2>>"%LogPath%"
) ELSE (
	Set /a ERROR+=1
	ECHO ^<p^>^<font color=red^>User doesn't have permission to query registry entry of OS info^</font^>^</p^> >> "%ResultPath%"
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
)

WMIC /NameSpace:\\root\default Class StdRegProv Call CheckAccess hDefKey=%HKEY_LOCAL_MACHINE% sSubKeyName="HARDWARE\DESCRIPTION\System\CentralProcessor" uRequired=%KEY_QUERY_VALUE% 1>nul 2>>"%LogPath%"
IF ERRORLEVEL 0 (
	CALL :CollectProcessorInfo 1>nul 2>>"%LogPath%"
) ELSE (
	Set /a ERROR+=1
	ECHO ^<p^>^<font color=red^>User doesn't have permission to query registry entry of processor info^</font^>^</p^> >> "%ResultPath%"
	ECHO ^<td^>N/A^</td^> >> "%ResultPath%"
)

CALL :CollectTotalPhysicalMemory 1>nul 2>>"%LogPath%"
ECHO ^</tr^> >> "%ResultPath%"
ECHO ^</table^> >> "%ResultPath%"
ECHO Collecting System Information Done
ECHO.

IF "%dc%"=="" (
	SET dc=NULL
)

:: Build up table for bandwidth
ECHO ^<p^>^<font size="5"^>Bandwidth:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>Datacenter^</th^> >> "%ResultPath%"
ECHO ^<th^>Test url^</th^> >> "%ResultPath%"
ECHO ^<th^>Bandwidth result^</th^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"
:: Collect Bandwidth for AZ, EU, AU and SH  Datacenters
ECHO Bandwidth test starts...
@rem ECHO    **************************************************************************
ECHO   Note: Bandwidth test will run against datacenters you have specified.
ECHO   Each test will run 5 rounds and results will be averaged.
ECHO   This test may take a couple of minutes. Please wait until it's done.
@rem ECHO    **************************************************************************
ECHO.

SET MYDC=%dc:https://=%
SET MYDC=%MYDC:http://=%

GOTO :Bandwidth_Test
:Bandwidth_Test
IF /I %dc% EQU NULL (
	CALL :BandwidthTest_DC AZ %AZURL%
	
	CALL :BandwidthTest_DC EU %EUURL%
	
	CALL :BandwidthTest_DC ASH %ASHURL%
	
	CALL :BandwidthTest_DC AU %AUURL%
	
	CALL :BandwidthTest_DC SH %SHURL%
	
	CALL :BandwidthTest_DC TO %TOURL%
	
) ELSE IF /I %dc% EQU AZ (
	CALL :BandwidthTest_DC AZ %AZURL%
) ELSE IF /I %dc% EQU EU (
	CALL :BandwidthTest_DC EU %EUURL%
) ELSE IF /I %dc% EQU ASH (
	CALL :BandwidthTest_DC ASH %ASHURL%
) ELSE IF /I %dc% EQU SH (
	CALL :BandwidthTest_DC SH %SHURL%
) ELSE IF /I %dc% EQU AU (
	CALL :BandwidthTest_DC AU %AUURL%
) ELSE IF /I %dc% EQU TO (
	CALL :BandwidthTest_DC TO %TOURL%
) ELSE IF /I %dc% EQU PM12EU (
	CALL :BandwidthTest_DC PM12EU %PM12EUURL%
) ELSE IF /I %dc% EQU PM2CNCDN (
	CALL :BandwidthTest_DC PM2CNCDN %PM2CNCDNURL%
) ELSE IF /I %dc% EQU PM012CDN (
	CALL :BandwidthTest_DC PM012CDN %PM012CDNURL%
) ELSE IF /I %dc% EQU PM52 (
	CALL :BandwidthTest_DC PM52 %PM52URL%
) ELSE IF /I %dc% EQU PM5CNCDN (
	CALL :BandwidthTest_DC PM5CNCDN %PM5CNCDNURL%
) ELSE IF /I %dc% EQU PM41 (
	CALL :BandwidthTest_DC PM41 %PM41URL%
) ELSE IF /I %dc% EQU PM42 (
	CALL :BandwidthTest_DC PM42 %PM42URL%
) ELSE IF /I %dc% EQU PM4CNCDN (
	CALL :BandwidthTest_DC PM4CNCDN %PM4CNCDNURL%
) ELSE IF /I %dc% EQU AMWAY (
	CALL :BandwidthTest_DC AMWAY %AMWAYURL%
) ELSE IF /I %dc% EQU PM8CDN (
	CALL :BandwidthTest_DC PM8CDN %PM8CDNURL%
) ELSE IF /I %dc% EQU PM11 (
	CALL :BandwidthTest_DC PM11 %PM11URL%
) ELSE IF /I %dc% EQU PM12COM (
	CALL :BandwidthTest_DC PM12COM %PM12COMURL%
) ELSE IF /I %dc% EQU PM8CNCDN (
	CALL :BandwidthTest_DC PM8CNCDN %PM8CNCDNURL%
) ELSE IF /I %dc% EQU PM10CDN (
	CALL :BandwidthTest_DC PM10CDN %PM10CDNURL%
) ELSE IF /I %dc% EQU PM10CNCDN (
	CALL :BandwidthTest_DC PM10CNCDN %PM10CNCDNURL%
) ELSE IF NOT %dc:successfactors=%==%dc% (

	FOR /f "delims=/" %%a in ("%MYDC%") do (		
		SET MYDC=%%a
	)
	ECHO Collecting Bandwidth to SuccessFactors %MYDC% DataCenter...
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>%MYDC%^</td^> >> "%ResultPath%"
	ECHO ^<td^>^<a href="https://%MYDC%/diagnostic/main"^>https://%MYDC%/diagnostic/main^</a^>^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"
	cscript //Nologo "%ScriptPath%\bandwidth-test.vbs" https://%MYDC%>> "%ResultPath%"
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"

	ECHO Collecting Bandwidth to SuccessFactors %MYDC% DataCenter Done
) ELSE (
	SET dc=NULL
	GOTO:Bandwidth_Test
)
ECHO ^</table^> >> "%ResultPath%"

:: Build up table for Diagnostic Information
ECHO ^<p^>^<font size="5"^>Diagnostic Page Information:^</font^>^</p^> >> "%ResultPath%"
:: Collect Diagnostic Information for the target dc collected from beginning
ECHO Collecting Diagnostic Information...
IF /I %dc% EQU AZ (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %AZURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU EU (	
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %EUURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU ASH (	
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %ASHURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU NULL (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %ASHURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU AU (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %AUURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU SH (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %SHURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU TO (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %TOURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM12EU (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM12EUURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM12EU (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM12EUURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM2CNCDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM2CNCDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM52 (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM52URL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM5CNCDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM5CNCDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM41 (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM41URL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM42 (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM42URL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM4CNCDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM4CNCDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU AMWAY (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %AMWAYURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM8CDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM8CDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM11 (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM11URL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM12COM (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM12COMURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM8CNCDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM8CNCDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM10CDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM10CDNURL% >> "%ResultPath%"
) ELSE IF /I %dc% EQU PM10CNCDN (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" %PM10CNCDNURL% >> "%ResultPath%"
) ELSE (
	cscript //Nologo "%ScriptPath%\diagnostic-page.vbs" https://%MYDC% >> "%ResultPath%"
)
ECHO Collecting Diagnostic Information Done

:Tracert_Test
:: Build up table for Tracert
ECHO Collecting Traceroute Information...
ECHO ^<p^>^<font size="5"^>Traceroute Result:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table id=^"Traceroute_result^" border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>Datacenter^</th^> >> "%ResultPath%"
ECHO ^<th^>Traceroute Result^</th^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"


IF /I %dc% EQU NULL (
	CALL :TracertTest_DC AZ %AZ%
	CALL :TracertTest_DC EU %EU%
	CALL :TracertTest_DC ASH %ASH%
	CALL :TracertTest_DC AU %AU%
	CALL :TracertTest_DC SH %SH%
	CALL :TracertTest_DC TO %TO%
	
) ELSE IF /I %dc% EQU AZ (
    CALL :TracertTest_DC AZ %AZ%
) ELSE IF /I %dc% EQU EU (
	CALL :TracertTest_DC EU %EU%
) ELSE IF /I %dc% EQU ASH (
	CALL :TracertTest_DC ASH %ASH%
) ELSE IF /I %dc% EQU AU (
	CALL :TracertTest_DC AU %AU%
) ELSE IF /I %dc% EQU SH (
	CALL :TracertTest_DC SH %SH%
) ELSE IF /I %dc% EQU TO (
	CALL :TracertTest_DC TO %TO%
) ELSE IF /I %dc% EQU PM12EU (
	CALL :TracertTest_DC PM12EU %PM12EU%
) ELSE IF /I %dc% EQU PM2CNCDN (
	CALL :TracertTest_DC PM2CNCDN %PM2CNCDN%
) ELSE IF /I %dc% EQU PM012CDN (
	CALL :TracertTest_DC PM012CDN %PM012CDN%
) ELSE IF /I %dc% EQU PM52 (
	CALL :TracertTest_DC PM52 %PM52%
) ELSE IF /I %dc% EQU PM5CNCDN (
	CALL :TracertTest_DC PM5CNCDN %PM5CNCDN%
) ELSE IF /I %dc% EQU PM41 (
	CALL :TracertTest_DC PM41 %PM41%
) ELSE IF /I %dc% EQU PM42 (
	CALL :TracertTest_DC PM42 %PM42%
) ELSE IF /I %dc% EQU PM4CNCDN (
	CALL :TracertTest_DC PM4CNCDN %PM4CNCDN%
) ELSE IF /I %dc% EQU AMWAY (
	CALL :TracertTest_DC AMWAY %AMWAY%
) ELSE IF /I %dc% EQU PM8CDN (
	CALL :TracertTest_DC PM8CDN %PM8CDN%
) ELSE IF /I %dc% EQU PM11 (
	CALL :TracertTest_DC PM11 %PM11%
) ELSE IF /I %dc% EQU PM12COM (
	CALL :TracertTest_DC PM12COM %PM12COM%
) ELSE IF /I %dc% EQU PM8CNCDN (
	CALL :TracertTest_DC PM8CNCDN %PM8CNCDN%
) ELSE IF /I %dc% EQU PM10CDN (
	CALL :TracertTest_DC PM10CDN %PM10CDN%
) ELSE IF /I %dc% EQU PM10CNCDN (
	CALL :TracertTest_DC PM10CNCDN %PM10CNCDN%
) ELSE (
	ECHO ^<td^>%MYDC%^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"
	ECHO ^<pre^> >> "%ResultPath%"	
	TRACERT %MYDC% >> "%ResultPath%"
	ECHO ^</pre^> >> "%ResultPath%"	
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
)
ECHO ^</table^> >> "%ResultPath%"
ECHO Collecting Traceroute Information Done

:Ping_Test
:: Build up table for Ping
ECHO Collecting Ping Information...
ECHO ^<p^>^<font size="5"^>Ping Result:^</font^>^</p^> >> "%ResultPath%"
ECHO ^<table id=^"ping_result^" border=^"1^"^> >> "%ResultPath%"
ECHO ^<tr style="color:blue"^> >> "%ResultPath%"
ECHO ^<th^>Datacenter^</th^> >> "%ResultPath%"
ECHO ^<th^>Ping Result^</th^> >> "%ResultPath%"
ECHO ^</tr^> >> "%ResultPath%"
IF /I %dc% EQU NULL (
	CALL :PINGTest_DC AZ %AZ%
	CALL :PINGTest_DC EU %EU%
	CALL :PINGTest_DC ASH %ASH%
	CALL :PINGTest_DC AU %AU%
	CALL :PINGTest_DC SH %SH%
	CALL :PINGTest_DC TO %TO%
	
) ELSE IF /I %dc% EQU AZ (

	CALL :PINGTest_DC AZ %AZ%
) ELSE IF /I %dc% EQU EU (
	CALL :PINGTest_DC EU %EU%
) ELSE IF /I %dc% EQU ASH (
	CALL :PINGTest_DC ASH %ASH%
) ELSE IF /I %dc% EQU TO (
	CALL :PINGTest_DC TO %TO%
) ELSE IF /I %dc% EQU AU (
	CALL :PINGTest_DC AU %AU%
) ELSE IF /I %dc% EQU SH (
	CALL :PINGTest_DC SH %SH%
) ELSE IF /I %dc% EQU PM12EU (
	CALL :PINGTest_DC PM12EU %PM12EU%
) ELSE IF /I %dc% EQU PM2CNCDN (
	CALL :PINGTest_DC PM2CNCDN %PM2CNCDN%
) ELSE IF /I %dc% EQU PM012CDN (
	CALL :PINGTest_DC PM012CDN %PM012CDN%
) ELSE IF /I %dc% EQU PM52 (
	CALL :PINGTest_DC PM52 %PM52%
) ELSE IF /I %dc% EQU PM5CNCDN (
	CALL :PINGTest_DC PM5CNCDN %PM5CNCDN%
) ELSE IF /I %dc% EQU PM41 (
	CALL :PINGTest_DC PM41 %PM41%
) ELSE IF /I %dc% EQU PM42 (
	CALL :PINGTest_DC PM42 %PM42%
) ELSE IF /I %dc% EQU PM4CNCDN (
	CALL :PINGTest_DC PM4CNCDN %PM4CNCDN%
) ELSE IF /I %dc% EQU AMWAY (
	CALL :PINGTest_DC AMWAY %AMWAY%
) ELSE IF /I %dc% EQU PM8CDN (
	CALL :PINGTest_DC PM8CDN %PM8CDN%
) ELSE IF /I %dc% EQU PM11 (
	CALL :PINGTest_DC PM11 %PM11%
) ELSE IF /I %dc% EQU PM12COM (
	CALL :PINGTest_DC PM12COM %PM12COM%
) ELSE IF /I %dc% EQU PM8CNCDN (
	CALL :PINGTest_DC PM8CNCDN %PM8CNCDN%
) ELSE IF /I %dc% EQU PM10CDN (
	CALL :PINGTest_DC PM10CDN %PM10CDN%
) ELSE IF /I %dc% EQU PM10CNCDN (
	CALL :PINGTest_DC PM10CNCDN %PM10CNCDN%
) ELSE (
	ECHO Collecting Ping Information for %MYDC%...
	ECHO ^<td^>%MYDC%^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"
	ECHO ^<pre^> >> "%ResultPath%"
	ECHO PING %MYDC% with 32 bytes
	PING %MYDC% >> "%ResultPath%"
	ECHO PING %MYDC% with 1024 bytes
	PING %MYDC% -l 1024 >> "%ResultPath%"
	ECHO PING %MYDC% with 2048 bytes
	PING %MYDC% -l 2048 >> "%ResultPath%"
	ECHO PING %MYDC% with 4096 bytes
	PING %MYDC% -l 4096 >> "%ResultPath%"
	ECHO PING %MYDC% with 8192 bytes
	PING %MYDC% -l 8192 >> "%ResultPath%"
	ECHO ^</pre^> >> "%ResultPath%"	
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	ECHO Collecting Ping Information for %MYDC% Done
) 

ECHO ^</table^> >> "%ResultPath%"
ECHO Collecting Ping Information Done

:: Done


ECHO ^<br^> >> "%ResultPath%"
ECHO ^<center^> >> "%ResultPath%"
ECHO ^<hr style="width:80%%" size="2px" color="gray"^> >> "%ResultPath%"
ECHO Contact: Please consult with your Customer Success Representatives if you have any questions. >> "%ResultPath%"
ECHO ^<br^> >> "%ResultPath%"
::ECHO Copyright: (C) 2013 SuccessFactors, an SAP Company  ^</center^> >> "%ResultPath%"
ECHO ^</body^> >> "%ResultPath%"
ECHO ^</html^> >> "%ResultPath%"
ECHO.
@rem ECHO    **************************************************************************
IF %ERROR% EQU 0 (
	ECHO Test completed, no error detected. 
	ECHO Please find test result at "%ResultPath%".
) ELSE (
	ECHO Test completed, but there is %ERROR% error^(s^). 
	ECHO Please find test result at "%ResultPath%".
    ECHO.
	ECHO Please contact with your Customer Success Representatives and send "%ResultPath%" and "%LogPath%" files.
)
@rem Command window stays until user's click of any key to exit
PAUSE
ENDLOCAL
GOTO:EOF

:CollectIESetting
:: Check IE Version
:: delims is a TAB followed by a space
FOR /F "tokens=3* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v "User Agent"') DO SET IEVersion=%%B
ECHO ^<td^>%IEVersion%^</td^> >> "%ResultPath%"

:1
:: Check Browser Setting
:: Check "Check for newer versions of stored pages"
REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v SyncMode5
IF %ERRORLEVEL% EQU 1 (
	:: 'Automatically' by default if SyncMode5 not found. Tested on XP Pro SP3, Win 2003, Win 7, azhang, 130407
	ECHO ^<td^>Automatically^</td^> >> "%ResultPath%"
	GOTO:2
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v SyncMode5') DO SET CheckForNewerVersionOrNot=%%B
IF %CheckForNewerVersionOrNot% EQU 4 (
	ECHO ^<td^>Automatically^</td^> >> "%ResultPath%"
) ELSE (
	ECHO ^<td^>^<font color=red^>Not set to Automatically^</font^>^</td^> >> "%ResultPath%"
)

:2
:: Check "The amount of disk space to use for Temporary Internet Files folder"
REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\5.0\Cache\Content" /v CacheLimit
IF %ERRORLEVEL% EQU 1 (
	Set /a ERROR+=1
	ECHO ^<td^>^<font color="red"^>N/A^</font^>^</td^> >> "%ResultPath%"
	GOTO:3
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\5.0\Cache\Content" /v CacheLimit') DO SET DiskSpace=%%B
set /a Convert=%DiskSpace%/1024
ECHO ^<td^>%Convert% MB^</td^> >> "%ResultPath%"

:3
:: Check "Use Http 1.1"
REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v EnableHttp1_1
IF %ERRORLEVEL% EQU 1 (
	Set /a ERROR+=1
	ECHO ^<td^>^<font color="red"^>N/A^</font^>^</td^> >> "%ResultPath%"
	GOTO:4
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v EnableHttp1_1') DO SET UseHttp11OrNot=%%B
IF %UseHttp11OrNot% EQU 1 (
	ECHO ^<td^>Yes^</td^> >> "%ResultPath%"
) ELSE (
	ECHO ^<td^>^<font color=red^>No^</font^>^</td^> >> "%ResultPath%"
)

:4
:: Check "Use Http 1.1 throught proxy connections"
REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyHttp1.1
IF %ERRORLEVEL% EQU 1 (
	Set /a ERROR+=1
	ECHO ^<td^>^<font color="red"^>N/A^</font^>^</td^> >> "%ResultPath%"
	GOTO:5
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyHttp1.1') DO SET UseProxyHttp11OrNot=%%B
IF %UseProxyHttp11OrNot% EQU 1 (
	ECHO ^<td^>Yes^</td^> >> "%ResultPath%"
) ELSE (
	ECHO ^<td^>^<font color=red^>No^</font^>^</td^> >> "%ResultPath%"
)

:5
:: Check "Do not save encrypted pages to disk"
REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings" /v DisableCachingOfSSLPages
IF %ERRORLEVEL% EQU 1 (
	Set /a ERROR+=1
	ECHO ^<td^>^<font color="red"^>N/A^</font^>^</td^> >> "%ResultPath%"
	GOTO:6
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings" /v DisableCachingOfSSLPages') DO SET EmptyOrNot=%%B
IF %EmptyOrNot% EQU 0 (
	ECHO ^<td^>Not checked^</td^> >> "%ResultPath%"
) ELSE (
	ECHO ^<td^>^<font color=red^>Checked^</font^>^</td^> >> "%ResultPath%"
)

:6
:: Check "Empty temporary internet files folder when browser is closed"
REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Cache" /v Persistent
IF %ERRORLEVEL% EQU 1 (
	Set /a ERROR+=1
	ECHO ^<td^>^<font color="red"^>N/A^</font^>^</td^> >> "%ResultPath%"
	GOTO:EOF
)
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Cache" /v Persistent') DO SET SaveOrNot=%%B
IF %SaveOrNot% EQU 1 (
	ECHO ^<td^>Not checked^</td^> >> "%ResultPath%"
) ELSE (
	ECHO ^<td^>^<font color=red^>Checked^</font^>^</td^> >> "%ResultPath%"
)
GOTO:EOF

:CollectOsInfo
:: Gather System/desktop Resources
:: Machine Name
FOR /f "tokens=2* delims=: " %%a IN ('systeminfo ^| findstr /c:"Host Name:"') DO SET MachineName=%%b
ECHO ^<td^>%MachineName%^</td^> >> "%ResultPath%"
:: OS Name
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v ProductName') DO SET OsName=%%B
ECHO ^<td^>%OsName%^</td^> >> "%ResultPath%"
:: OS Version
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v BuildLab') DO SET OsVersion=%%B
ECHO ^<td^>%OsVersion%^</td^> >> "%ResultPath%"
GOTO:EOF

:CollectProcessorInfo
:: Processor Info
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKLM\HARDWARE\DESCRIPTION\System\CentralProcessor\0" /v Identifier') DO SET ProcessorIdentifier=%%B
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKLM\HARDWARE\DESCRIPTION\System\CentralProcessor\0" /v ProcessorNameString') DO SET ProcessorNameString=%%B
Set ProcessorInfo=%ProcessorIdentifier% %ProcessorNameString%
ECHO ^<td^>%ProcessorInfo%^</td^> >> "%ResultPath%"
GOTO:EOF

:CollectTotalPhysicalMemory
:: Total physical memory

FOR /f "tokens=4* delims=: " %%a IN ('systeminfo ^| findstr /c:"Total Physical Memory:"') DO SET TotalMemWithComma=%%a
SET TotalMem=%TotalMemWithComma:,=%
ECHO ^<td^>%TotalMem% MB^</td^> >> "%ResultPath%"
GOTO :EOF

:BandwidthTest_DC

	ECHO Collecting Bandwidth to SuccessFactors %1 DataCenter...
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>%1^</td^> >> "%ResultPath%"
	ECHO ^<td^>^<a href="%2/diagnostic/main"^>%2/diagnostic/main^</a^>^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"
	cscript //Nologo "%ScriptPath%\bandwidth-test.vbs" %2 >> "%ResultPath%"
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	
	ECHO Collecting Bandwidth to SuccessFactors %1 DataCenter Done

GOTO :EOF

:TracertTest_DC
	ECHO Collecting Traceroute Information for %1 ...
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>%1, >> "%ResultPath%"
	ECHO ^<br /^>%2^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"	
	ECHO ^<pre^> >> "%ResultPath%"	
	TRACERT %2 >> "%ResultPath%"
	ECHO ^</pre^> >> "%ResultPath%"	
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	ECHO Collecting Traceroute Information for %1 Done
	
GOTO :EOF

:PINGTest_DC
	ECHO Collecting Ping Information for %1...
	ECHO ^<tr^> >> "%ResultPath%"
	ECHO ^<td^>%1, >> "%ResultPath%"
	ECHO ^<br /^>%2^</td^> >> "%ResultPath%"
	ECHO ^<td^> >> "%ResultPath%"
	ECHO ^<pre^> >> "%ResultPath%"	
	ECHO PING %2 with 32 bytes
	PING %2 >> "%ResultPath%"
	ECHO PING %2 with 1024 bytes
	PING %2 -l 1024 >> "%ResultPath%"
	ECHO PING %2 with 2048 bytes
	PING %2 -l 2048 >> "%ResultPath%"
	ECHO PING %2 with 4096 bytes
	PING %2 -l 4096 >> "%ResultPath%"
	ECHO PING %2 with 8192 bytes
	PING %2 -l 8192 >> "%ResultPath%"
	ECHO ^</pre^> >> "%ResultPath%"	
	ECHO ^</td^> >> "%ResultPath%"
	ECHO ^</tr^> >> "%ResultPath%"
	ECHO Collecting Ping Information for %1 Done
GOTO :EOF	


IF "%OS%"=="Windows_NT" ENDLOCAL
GOTO :EOF

:Usage
ECHO.
ECHO performance_diagnostic_tool.zip
ECHO Platform Supported:
ECHO   Operating System: Windows XP Pro/Windows 2003/Windows 7
ECHO   Web Browser: IE7/IE8/IE9
ECHO Description: Collect IE browser setting, OS/hardware spec of current machine, network bandwidth and other diagnostic information
ECHO.
ECHO Usage:  1. Extract the package (performance_diagnostic_tool.zip) to your local
ECHO         2. Open Windows command prompt window
ECHO            2.1 Click Windows Start menu
ECHO            2.2 Run...
ECHO            2.3 Type cmd
ECHO            2.4 Click OK
ECHO         3. Go to the directory where you have extracted the package
ECHO            3.1 Type "cd <full directory path>" without quotes in cmd window, e.g. cd C:\test
ECHO            3.2 If the package is extracted to anther disk drive (eg. D:\test), please first type "D:" without quotes and press Enter, then type "cd D:\test" without quotes and press Enter
ECHO         4. Type "Run.bat" in the command line without quotes and press Enter
ECHO.        
ECHO Notes:  Requires WMIC, which is native in Windows XP Professional, Windows Server 2003 and Windows 7
ECHO         The results are written to a "perf_data_YY_MM_DD_TIME.html" file in Results folder
ECHO.
ECHO Contact: Please consult with your Customer Success Representatives if you have any questions.

:End
@ENDLOCAL
EXIT /B 1











